import React, { useState } from 'react';
import {motion, useScroll, useMotionValueEvent, useTransform} from "framer-motion"

const NavMenu = () => {

    const { scrollYProgress } = useScroll();
    const menu_offset = useTransform(scrollYProgress, [0,0.1], ['50%', '100%']);
    const menu_offset_l = useTransform(scrollYProgress, [0,0.1], ['-50%', '-100%']);
    const [scrollPosition, setScrollPosition] = useState(0.0);

    useMotionValueEvent(scrollYProgress, "change", (latest) => {
        setScrollPosition(latest);
      })

    return (
        <motion.div className={'sticky top-0 left-0 right-0 w-full px-12 h-24 transition-all duration-100 bg-transparent flex items-center text-xl select-none '
                    + (scrollPosition > 0.0 ? "justify-end":"justify-center")}
                    // initial={{y:100, opacity: 0.1}}
                    // animate={{y: 0, opacity:1.0}}
                    // transition={{type: "tween", stiffness:300}}
                    >
            <div className='absolute top-0 left-12'>
                <p className='text-2xl font-bold translate-y-[100%]'>COMPANY NAME</p>
            </div>
            <div className='absolute top-0 left-12 right-12 bottom-0'>
                <div className='relative w-full h-full'>
                    <motion.div className='absolute flex gap-8 justify-center items-center'
                        transition={{type: "tween", duration: 0.5}}
                        initial={{left: "50%", translateX: "-50%", top: "50%", translateY: "-50%"}}
                        style={{left: menu_offset, translateX: menu_offset_l}}
                        >
                        <a href="##" className='hover:opacity-50 transition-all duration-100'>About</a>
                        <a href="##" className='hover:opacity-50 transition-all duration-100'>Services</a>
                        <a href="##" className='hover:opacity-50 transition-all duration-100'>Steps</a>
                        <a href="##" className='hover:opacity-50 transition-all duration-100'>Contact</a>
                    </motion.div>
                </div>
            </div>
        </motion.div>
    );
}

export default NavMenu;
